VERSION 5.00
Begin VB.Form Form1 
   Appearance      =   0  'Flat
   BackColor       =   &H80000005&
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Arduino TV Music"
   ClientHeight    =   3195
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton Command1 
      Appearance      =   0  'Flat
      Caption         =   "Write notes.h file"
      Height          =   375
      Left            =   120
      TabIndex        =   2
      Top             =   2400
      Width           =   4335
   End
   Begin VB.ListBox List1 
      Appearance      =   0  'Flat
      Height          =   1980
      Left            =   120
      TabIndex        =   0
      Top             =   0
      Width           =   4335
   End
   Begin VB.Label Label1 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Select music data file"
      ForeColor       =   &H80000008&
      Height          =   255
      Left            =   240
      TabIndex        =   1
      Top             =   2880
      Width           =   4215
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Set here number of songs in songlist.txt
Const MAXSONG = 48
Dim tarray$(MAXSONG * 2)
Dim re() As Byte
Dim cnt As Integer
Dim songcnt As Integer

Function CountNotes()
If List1.ListIndex < 0 Then
  CountNotes = 0: Exit Function
End If
dat$ = tarray$(2 * List1.ListIndex + 1)
c = 0
For i = 1 To Len(dat$)
  If Mid$(dat$, i, 1) = "$" Then c = c + 1
Next i
CountNotes = c
End Function

Private Sub Command1_Click()
If List1.ListIndex < 0 Then
  MsgBox "Select a song first", , "Arduino TV Music": Exit Sub
End If
nam$ = tarray$(2 * List1.ListIndex)
dat$ = tarray$(2 * List1.ListIndex + 1)
'Open "c:\ringxmas\notes.h" For Output As #1
Open "notes.h" For Output As #1
Print #1, "//"; nam$
Print #1, "const PROGMEM unsigned char notes[]={"
c = 0: i = 1
While i <= Len(dat$)
a$ = Mid$(dat$, i, 1)
If a$ = "$" Then
  b$ = Mid$(dat$, i + 1, 2): i = i + 2
  Print #1, "0x"; b$; ",";
  c = c + 1
  If (c Mod 16) = 0 Then Print #1, ""
End If
i = i + 1
Wend
Print #1, "0xFF};"
Close #1
End Sub

Private Sub Form_Load()
Command1.Left = 0: Command1.Width = Form1.Width
List1.Left = 0: List1.Top = 0
List1.Width = Form1.Width - 12
List1.Height = Command1.Top
Label1.Left = 0: Label1.Width = Form1.Width
' Load song data (text of bytes) from resource
re = LoadResData(101, "CUSTOM")
'MsgBox Chr$(re(0)) + " " + Str$(Len(re(0)))
'Open "c:\ringxmas\ringxmas.txt" For Input As #1
'cnt = 0
'While Not EOF(1)
'Line Input #1, tarray$(cnt)
'cnt = cnt + 1
'Wend
'Close #1

'Convert bytes from re() to strings in tarray$()
cnt = 0: i = 0: d$ = ""
While cnt < MAXSONG * 2
r = re(i)
' if r - symbol code
If r >= 32 Then
  d$ = d$ + Chr$(r)
Else
  ' ir r=CR code
  If r = 13 Then
    tarray$(cnt) = d$: d$ = "": cnt = cnt + 1
  End If
End If
i = i + 1
Wend
i = 0: songcnt = 0
While i < cnt
a$ = tarray$(i)
If Mid$(a$, 1, 1) = "'" Then
  b$ = Mid$(a$, 2)
  List1.AddItem b$
  songcnt = songcnt + 1
End If
i = i + 1
Wend
End Sub


Private Sub List1_Click()
Label1.Caption = Str$(List1.ListIndex + 1) + Space$(4) + List1.Text
r = CountNotes()
If r <> 0 Then Label1.Caption = Label1.Caption + Space$(4) + Str$(r) + " notes"
End Sub
